/*
 * head.h
 * begin: 02.09.2005
 *
 * copyright (C) 2005 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#ifndef BUSIM_HEAD_H
#define BUSIM_HEAD_H


// prozatim pro ucely ladeni
#include <iostream>
using namespace std;


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "c00r/coor3.h"
#include "c00r/coor2.h"
#include "c00r/vector3.h"
#include <GL/gl.h>

// souradnice
typedef c00r::coor3<GLfloat> coor3f;
typedef c00r::coor3<GLdouble> coor3d;
typedef c00r::coor3<GLint> coor3n;
typedef c00r::coor2<GLint> coor2n;
// vektory
typedef c00r::vector3<GLfloat> vector3f;
typedef c00r::vector3<GLdouble> vector3d;
typedef c00r::vector3<GLint> vector3n;

// barva
struct Color
{
  GLfloat r, g, b, a;

  Color()
    :r(0), g(0), b(0), a(0)
  { }
  Color(GLfloat pr, GLfloat pg, GLfloat pb, GLfloat pa)
    :r(pr), g(pg), b(pb), a(pa)
  { }
};


#endif // BUSIM_HEAD_H

