/*
 * image.h
 * begin: 7.6.2006
 *
 * copyright (C) 2006 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#ifndef BUSIM_IMAGE_H
#define BUSIM_IMAGE_H

#include "eexception.h"
#include "head.h"

class Image {
protected:
	GLenum m_format;
	GLuint m_width, m_height;
	GLuint m_pointSize;
		
public:
	GLubyte *p_buffer;
	
	Image () {}
	~Image () {}

	GLenum getFormat () const
		{ return m_format; }
	GLuint getWidth () const
		{ return m_width; }
	GLuint getHeight () const
		{ return m_height; }
	GLuint getPointSize () const
		{ return m_pointSize; }
	GLuint getPoint (GLuint x, GLuint y)
		{ return p_buffer[(y*m_width + x)*m_pointSize]; }
};

class JpegImage :public Image {
public:
	JpegImage (const char *filename);
	~JpegImage ();

	/* vyjimky */
	class EOpenFailed :public h4e3r::EException {
		static char *_comment;
	public:
		EOpenFailed() :EException(_comment) {}
	};
};

class TiffImage :public Image {
public:
	TiffImage (const char *filename);
	~TiffImage ();

	/* vyjimky */
	class EOpenFailed :public h4e3r::EException {
		static char *_comment;
	public:
		EOpenFailed() :EException(_comment) {}
	};
};


#endif // BUSIM_IMAGE_H

