/*
 * land.cpp
 * begin: 3.11.2005
 *
 * copyright (C) 2005 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#ifndef BUSIM_LAND_H
#define BUSIM_LAND_H

#include "head.h"
#include "image.h"
#include "object.h"



class LandField {
	public:
	coor3f points[4];
	vector3f normal; // Hlavni normala plochy
	vector3f normals[4]; // Normaly bodu

	void draw(const unsigned int &a, const unsigned int &b, const unsigned int &w, const unsigned int &h);
	void computeMainNormal();
	void computeNormals(const LandField &f0, const LandField &f1, const LandField &f2, const LandField &f3, const LandField &f4, const LandField &f5, const LandField &f6, const LandField &f7);
};

class OLand :public OObject
{
	
	LandField *p_map;
	Image *p_image;
	long m_texture;
	unsigned int m_width;
	unsigned int m_height;

	unsigned int m_field_size;
	float m_altitude_factor;

	unsigned int m_displayList;

	//// map
	// Vrati odkaz na field na poli x,y
	LandField &map(unsigned int x, unsigned int y) {
		return p_map[(x * (m_width - 1)) + y];
	}

	void createMap();
	void computeNormals();
	void drawMap();
	
public:
	OLand (const char *height_map, const char *texture = NULL, unsigned int field_size = 8, float altitude_factor=0.25);
	~OLand ();

	void draw ();
};



#endif // BUSIM_LAND_H

