/*
 * main.cpp
 * begin: 02.09.2005
 *
 * copyright (C) 2005 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#include "head.h"
#include "sdlstuff.h"
#include "scene.h"
#include "image.h"
#include "texturemanager.h"
#include "land.h"
#include <iostream>
#include <cmath>

using namespace std;


int main (int argc, char **argv)
{
	char *heightmap = "Terrain_heightmap-128x128.jpg";
	char *texture = "Terrain_texture.jpg";

	if(argc >= 2)
		heightmap = argv[1];
	if(argc >= 3)
		texture = argv[2];

	SDLStuff sdl;
	sdl.wndInit("Terrain");
	
	g_scene.init();
	g_scene.m_bgColor = Color(0.4, 0.4, 1.0, 0.0);
//	g_scene.setFog(Color(0.4, 0.4, 0.6, 1), 0.003);
	g_scene.resize(g_screenSize);


	OLand *l = new OLand(heightmap, texture, 4, 0.1);
	g_scene.add(l);
	
	// Vychozi poloha
	g_scene.m_spectator.translation(coor3f(-40, 30, -40));
	g_scene.m_spectator.roty(M_PI*0.75);
	
	sdl.loop();

	return 0;
}
