/*
 * mymem.cc
 * begin: 26.7.2003
 *
 * copyright (C) 2003-2004 by Jan Ehrenberger < Honza_E@atlas.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#include "mymem.h"
#include <cstring>

using namespace std;


namespace h4e3r
{
  char *ENullPointer::_comment = "Can't access null pointer";

  handle_base& handle_base::operator=(handle_base a)
  {
    if( a.rep==rep ) return *this;
    _free();
    rep = a.rep;
    if( rep ) rep->incr();
    return *this;
  }

  void convert(handle_base& to, const handle_base& from)
  {
    to.free();
    to.rep = from.rep;
    if( to.rep ) to.rep->incr();
  }


  string_handle::string_handle(const char* s)
  {
    if (s) {
      alloc(strlen(s)+1);
      strcpy(get_ptr(), s);
    }
  }

  string_handle::string_handle(const char* s, const size_t& len)
    :array_handle<char>(len+1)
  {
    strcpy(get_ptr(), s);
  }

  size_t string_handle::len() const
  {
    return strlen(get_ptr());
  }

  const string_handle& string_handle::copy(const char *a)
  {
    alloc(strlen(a)+1);
    strcpy(get_ptr(), a);
    return *this;
  }

  const string_handle& string_handle::copy(const char *a, const size_t& len)
  {
    alloc(len+1);
    strcpy(get_ptr(), a);
    return *this;
  }

  /* kdyz je a mensi, vraci cislo mensi nez nula, kdyz je stejne, vraci nulu
     a kdyz je vetsi, vraci cislo vetsi nez nula */
  int string_handle::cmp(const char *a) const
  {
    return strcmp(a, get_ptr());
  }

} /* namespace h4e3r */
