/*
 * object.cpp
 * begin: 08.10.2005
 *
 * copyright (C) 2005 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#include "object.h"
#include "scene.h"
#include <fstream>
#include <iostream>

using namespace std;

/*** OObject ***/
unsigned long int OObject::m_objectCounter = 0;

/*** OMultiple ***/
OMultiple::~OMultiple()
{
  for (objectList::iterator iA = m_objects.begin(); iA != m_objects.end(); iA++)
    delete *iA;
}

void OMultiple::draw()
{
  for (objectList::iterator iA = m_objects.begin(); iA != m_objects.end(); iA++)
    (*iA)->draw();
}

void OMultiple::update()
{
  for (objectList::iterator iA = m_objects.begin(); iA != m_objects.end(); iA++) {
    (*iA)->update();
    if (!(*iA)->m_alive) {
      objectList::iterator iT = iA;
      ++iT;
      delete *iA;
      m_objects.erase(iA);
      iA = iT;
    }
  }
}

// OExternal
OExternal::OExternal (const char *fname)
{
	char buf[1024];
	ifstream file(fname);
	file >> buf;
	cout << buf << endl;
}


