/*
 * scene.h 
 * begin: 08.10.2005
 *
 * copyright (C) 2005 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#ifndef BUSIM_SCENE_H
#define BUSIM_SCENE_H

#include "head.h"
#include "object.h"

#define MIN_FPS 10

class Scene :public OMultiple
{
	const int m_viewDistance;
	unsigned int m_lastRender;
	unsigned short int m_count; // pocitadlo volani funkce render
	int m_polygonMode; // pozuty polygon mode
	float m_fps;

	void calculateFPS();
	void checkKeyb();

public:
	Matrix m_spectator;
	Matrix m_camera;
	Color m_bgColor;

	Scene()
	:m_viewDistance(1000), m_count(0)
	{ }
	~Scene();

	void init();
	void setFog(const Color& col, const GLfloat& density);
	void render();
	void resize(const coor2n&);
	void update();
	void mouseMove(const coor2n&);
	GLfloat getFPS()
	{ return m_fps; }
	// timeMove - podle fps vypocita zmenu nejake veliciny v case
	GLfloat timeMove(GLfloat speed)
	{ return (getFPS() > MIN_FPS) ? speed/getFPS() : 0; }
};

extern Scene g_scene;

#endif // BUSIM_SCENE_H

