/*
 * text.cpp
 * begin: 23.11.2005
 *
 * copyright (C) 2005-2006 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

/*
 * inspirovano NeHe tutorialem (lekce 13.) a kodem k lekci by Jeff Molofee
 */

#include "text.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <GL/glx.h>
#include <SDL/SDL.h>


BuFont *g_font = NULL; // globalni font


BuFont::BuFont(const char *fname)
{
	Display *dpy;          /* Our current X display */
	XFontStruct *fontInfo; /* Our font info */

	// Sotrage for 96 characters 
	m_base = glGenLists(96);
	dpy = XOpenDisplay(NULL);
	// Get the font information 
	fontInfo = XLoadQueryFont(dpy, fname);

	// If the above font didn't exist try one that should
	if (fontInfo == NULL)
	{
		fontInfo = XLoadQueryFont(dpy, "fixed");
		// If that font doesn't exist, something is wrong
		if (fontInfo == NULL)
		{
			// zatim tu nic neni, pozdejc snad pridam nakou vyjimku
		}
	}

	glXUseXFont(fontInfo->fid, 32, 96, m_base); // generate the list
	XFreeFont(dpy, fontInfo);
	XCloseDisplay(dpy);

	// vynulovani textoveho bufferu
	for (int n = 0; n < 10; n++)
		m_text_buf[n][0] = (char)0;
}

BuFont::~BuFont()
{
	glDeleteLists(m_base, 96);
}

void BuFont::begin()
{
	glPushAttrib(GL_LIST_BIT);
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	glTranslatef( 0.0f, 0.0f, -1.0f );
	glColor3f(0.0f, 0.0f, 0.0f);
	glListBase(m_base - 32);
}

void BuFont::end()
{
	glEnable(GL_DEPTH_TEST);
	glPopAttrib();
}

void BuFont::printf(const char *text, ...)
{
	char buf[256];
	va_list g;

	if (text == NULL)
		return;
	va_start(g, text);
	vsprintf(buf, text, g);
	va_end(g);

	glCallLists(strlen(buf), GL_UNSIGNED_BYTE, buf);
}

void BuFont::print(const char *text)
{
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
}

void BuFont::buf_printf(int n, const char *text, ...)
{
	va_list g;

	if (text == NULL || n < 0 || n > 9)
		return;
	va_start(g, text);
	vsprintf(m_text_buf[n], text, g);
	va_end(g);
}

void BuFont::print_buf()
{
	for (int n = 0; n < 10; n++) 
		if (m_text_buf[n][0] != (char)0) {
			set_pos(-0.4, 0.02f*(GLfloat)n);
			glCallLists(strlen(m_text_buf[n]), GL_UNSIGNED_BYTE, m_text_buf[n]);
		}
}

