/*
 * texturemanager.h
 * begin: 11.10.2005
 *
 * copyright (C) 2005 by Jan Ehrenberger < lankvil@seznam.cz >
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */

#ifndef BUSIM_TEXTUREMANAGER_H
#define BUSIM_TEXTUREMANAGER_H

#include "head.h"
#include <map>
#include "mymem.h"
#include "eexception.h"

/* bude uchovavat vsechny textury v programu */
class TextureManager
{
  typedef std::map<h4e3r::string_handle, GLuint> map_t;
  map_t m_map; /* nazvy souboru priradi k identifikatoru textury */

public:
  enum format { tiff, jpeg };
  class EOpenFailed :public h4e3r::EException {
    static char *_comment;
  public:
    EOpenFailed() :EException(_comment) { }
  };
  class EUnknownFormat :public h4e3r::EException {
    static char *_comment;
  public:
    EUnknownFormat() :EException(_comment) { }
  };

  TextureManager();
  ~TextureManager();

  GLuint getFileTex(const char *, format) throw (h4e3r::EException, EOpenFailed, EUnknownFormat);
  GLuint getFileTex(const char *) throw (h4e3r::EException, EOpenFailed, EUnknownFormat); // autodetekce formatu podle pripony
};

extern TextureManager g_texMan; /* globalni spravce textur */

#endif // BUSIM_TEXTUREMANAGER_H
